//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
   
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Magenta
#property indicator_width1     1
#property indicator_color2     Aqua
#property indicator_width2     2
#property indicator_color3     White
#property indicator_style3     STYLE_DASH
#property indicator_color4     Crimson
#property indicator_width4     1
#property indicator_color5     LimeGreen
#property indicator_width5     1
#property indicator_level1     0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    Per              = 14;
extern int    T3Period         = 5;
extern int    T3Price          = PRICE_CLOSE;
extern double T3Hot            = 0.7;
extern bool   T3Original       = false;
extern int    HighLowPeriod    = 30;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;

//
//
//
//
//

double buf[];
double sig[];
double HighBuffer[];
double LowBuffer[];
double ZigZagBuffer[];
double ZigZagLow[];
double ZigZagHigh[];
double trend[];

//
//
//
//
//

double point = 0;
double pipMultiplier = 1;
int    digit; 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
  
int init() 
{
   digit = Digits;
   
   if(digit == 3 || digit == 5)
   { 
      point = Point * 10; 
      pipMultiplier = 10; 
   }
   else
   {
      point = Point;
      pipMultiplier = 1;
   }
   
   IndicatorBuffers(8);
      SetIndexBuffer(0,buf);
      SetIndexBuffer(1,sig);
      SetIndexBuffer(2,ZigZagBuffer);
      SetIndexBuffer(3,HighBuffer);
      SetIndexBuffer(4,LowBuffer);
      SetIndexBuffer(5,ZigZagLow);
      SetIndexBuffer(6,ZigZagHigh);
      SetIndexBuffer(7,trend);
      SetIndexStyle(2,DRAW_SECTION);
      SetIndexEmptyValue(0,0);
      SetIndexEmptyValue(1,0);
      SetIndexEmptyValue(2,0);
      SetIndexEmptyValue(5,0);
      SetIndexEmptyValue(6,0);
      SetIndexLabel(2,NULL);
      
          Per = MathMax(Per,1);
   
      //
      //
      //
      //
      //
      
         if (ShowChannel)
           {
           SetIndexStyle(3,DRAW_LINE);
           SetIndexStyle(4,DRAW_LINE);
           }
         else      
           {
           SetIndexStyle(3,DRAW_NONE);
           SetIndexStyle(4,DRAW_NONE);
           }
      
         
      //
      //
      //
      //
      //
      
      IndicatorShortName("DayImplus ("+Per+","+T3Period+","+DoubleToStr(T3Hot,2)+")");
      
   return(0);
}

//
//
//
//
//

int deinit(){  return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,limit;
   
   int lastZag;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           
   //
   //
   //
   //
   //
   
   if (ShowZigZag)
   for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;

   //
   //
   //
   //
   //
      
   for(i=limit; i>=0; i--)
   {
          double imp = 0;
          for (j=0; j<Per; j++)
          {  
          imp = imp + (Open[i+j] - Close[i+j]);  
          }
             
          imp = MathRound(imp/point);

             if(imp != 0) 
                imp  = -imp;
      
                    buf[i]  = iT3(imp,T3Period,T3Hot,T3Original,i);
                    sig[i]  = buf[i+2]; 
              LowBuffer[i]  = buf[ArrayMinimum(buf,HighLowPeriod,i)];
              HighBuffer[i] = buf[ArrayMaximum(buf,HighLowPeriod,i)];
                   trend[i] = trend[i+1];
                   
      if (buf[i] > LowBuffer[i]  && buf[i+1] == LowBuffer[i+1])  trend[i] =  1;  
      if (buf[i] < HighBuffer[i] && buf[i+1] == HighBuffer[i+1]) trend[i] = -1; 
      
   
      
      //
      //
      //
      //
      //
      
      if (!ShowZigZag) continue;
      
      ZigZagLow[i]  = 0;
         ZigZagHigh[i] = 0;
         if (LowBuffer[i] < LowBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == LowBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  LowBuffer[i];
                   ZigZagLow[i]          =  LowBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (HighBuffer[i] > HighBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == HighBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  HighBuffer[i];
                   ZigZagHigh[i]         =  HighBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (ZigZagBuffer[i] != 0)
            {
               ZigZagBuffer[i] = 0;
               for (lastZag=i+1; lastZag<Bars; lastZag++)
               {
                  if (ZigZagLow[lastZag]  != 0) { ZigZagBuffer[lastZag] = ZigZagLow[lastZag];  break; }
                  if (ZigZagHigh[lastZag] != 0) { ZigZagBuffer[lastZag] = ZigZagHigh[lastZag]; break; }
               }
              } 
            } 
                 
     return(0); 
     }
    
//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}


